/*
 *	subtitle editor
 *
 *	http://kitone.free.fr/subtitleeditor/
 *
 *	Copyright @ 2005-2006, kitone
 *
 *	Contact: kitone at free dot fr
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public
 *	License as published by the Free Software Foundation; either
 *	version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU
 *	General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public
 *	License along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA	02111-1307	USA
 *
 *	See gpl.txt for more information regarding the GNU General Public License.
 *
 *
 *	\file
 *	\brief 
 *	\author kitone (kitone at free dot fr)
 */

#include "ISubtitleEditor.h"
#include "DialogChangeFPS.h"

/*
 *
 */
DialogChangeFPS::DialogChangeFPS(BaseObjectType* cobject, const Glib::RefPtr<Gnome::Glade::Xml>& refGlade)
:Gtk::Dialog(cobject)
{
	refGlade->get_widget("comboSrc", m_comboSrc);
	refGlade->get_widget("comboDest", m_comboDest);

	m_comboSrc->set_active(1);
	m_comboDest->set_active(0);
}

/*
 * 
 */
double DialogChangeFPS::get_source()
{
	// TODO
	/*
	Glib::ustring value = m_comboSrc->get_active_text();

	if(value == "23.976 fps")
		return 23.976;
	else if(value == "25.000 fps")
		return 25.0;
	else if(value == "29.970 fps")
		return 29.970;
	*/
	unsigned int id = m_comboSrc->get_active_row_number();
	
	if(id == 0)
		return 23.976;
	else if(id == 1)
		return 25.000;
	else if(id == 2)
		return 29.970;
	
	return 0;
}


/*
 *
 */
double DialogChangeFPS::get_dest()
{
	// TODO
	/*
	Glib::ustring value = m_comboDest->get_active_text();

	if(value == "23.976 fps")
		return 23.976;
	else if(value == "25.000 fps")
		return 25.0;
	else if(value == "29.970 fps")
		return 29.970;
	*/
	
	unsigned int id = m_comboDest->get_active_row_number();
	
	if(id == 0)
		return 23.976;
	else if(id == 1)
		return 25.000;
	else if(id == 2)
		return 29.970;
	
	return 0;
}

/*
 *
 */
void DialogChangeFPS::execute()
{
	Document *doc = SE::getInstance()->getDocument();
	g_return_if_fail(doc);
	
	show();
	
	if(run() == Gtk::RESPONSE_OK)
	{
		double src = get_source();
		double dest = get_dest();

		if(src!=0 && dest!=0)
		{
			doc->get_subtitle_model()->changeFPS(src,dest);
		}
	}

	hide();
}


